#!/bin/bash
if [ $# -ne 3 ]; then
	echo "usage: hvacSim.sh -mode[p,r] postBody logfile"
	exit 0
fi
logfile=$3
# parameter list
sparam[0]=0
sparam[1]=0
sparam[2]=0
sparam[3]=0
sparam[4]=0
sparam[5]=0
sparam[6]=0
sparam[7]=0
sparam[8]=0
sparam[9]=0
sparam[10]=0
sparam[11]=0
sparam[12]=0
sparam[13]=0
sparam[14]=0
sparam[15]=0
sparam[16]=0
sparam[17]=0
#
# sane input in case of error
function defInput()
{
	sparam[0]=78
	sparam[1]=72
	sparam[2]=10
	sparam[3]=97
	sparam[4]=50
	sparam[5]=6
	sparam[6]=6
	sparam[7]=92
	sparam[8]=55
	sparam[9]=54
	sparam[10]=1200
	sparam[11]=74
	sparam[12]=1
	sparam[13]=335
	sparam[14]=335
	sparam[15]=180
	sparam[16]=74
	sparam[17]=0
}
#
# parse POST body into needed parameters
function parseEM()
{
	ref='^[0-9]+$'
	list1=`echo $1 | tr '\n' ' ' | sed 's/ //g' `
	list1=`echo $list1 | tr "\&" " "`
	n=0
	for tag in $list1
	do
		sparam[n]=`echo $tag | cut -d= -f2`
		if ! [[ ${sparam[n]} =~ $ref ]]; then
			if [ $n -lt 17 ] ; then
				defInput
			fi
		fi
		n=`expr $n + 1`
	done
}
#
# main script starts here
#parseEM "oSP=85&rSP=72&pSP=10&hs=97&cs=50&hv=6&cv=6&hd=92&cd=55&hu=54&co=1200&ra=74&fan=0&dp1=335&dp2=335&dp3=180&rat=74123&dT=00000"
# parse the variable list
parseEM $2
#
# assign them to better variable names
outAirT=${sparam[0]}
rs=${sparam[1]}
ro=${sparam[2]}
hs=${sparam[3]}
cs=${sparam[4]}
hv=${sparam[5]}
cv=${sparam[6]}
hd=${sparam[7]}
cod=${sparam[8]}
hu=${sparam[9]}
co=${sparam[10]}
rt=${sparam[11]}
fan=${sparam[12]}
damp0=${sparam[13]}
damp1=${sparam[14]}
damp2=${sparam[15]}
retAirT=${sparam[16]}
deltaT=${sparam[17]}
#
inT=$rt
hv=6
cv=6
#
if [ $deltaT -eq 0 ]; then
	deltaT=`expr $rs - $rt`
	deltaT=`expr $deltaT \* 1000 / 10`
fi
#
if [ $fan -ne 0 ]; then
	dp=`expr $co - 400`
	dp=`expr $dp / 10`
	if [ $dp -gt 90 ]; then
		dp=90
	fi
	damp0=`expr $dp + 270`
	co=`expr $co - $dp \* 4 / 9`
fi
co=`expr $co + $ro`
dp=`expr $damp0 - 270`
dp=`expr $dp \* 10 / 9`
inT=`expr 100 - $dp`
inT=`expr $outAirT \* $dp + $rt \* $inT`
inT=`expr $inT + 50`
inT=`expr $inT / 100`
if [ $rs -lt $inT ]; then
	cv=`expr $inT - $rs`
	cv=`expr $cv \* 13`
	damp2=180
	fan=1
elif [ $rs -gt $inT ]; then
	hv=`expr $rs - $inT`
	hv=`expr $hv \* 13`
	damp2=270
	fan=2
else
	damp2=203
	fan=0
fi
if [ $hv -gt 100 ]; then
	hv=100
elif [ $hv -lt   0 ]; then
	hv=0
fi
if [ $cv -gt 100 ]; then
	cv=100
elif [ $cv -lt   0 ]; then
	cv=0
fi
if [ $outAirT -lt 35 ]; then
	cv=5
fi
if [ $ro -eq 0 ]; then
	if [ $co -gt 400 ]; then
		if [ $damp0 -gt 270 ]; then
			if [ $fan -ne 0 ]; then
				co=`expr $co - 10`
			fi
		fi
	fi
fi
if [ $co -lt 400 ]; then
	co=400
elif [ $co -gt 500 ]; then
	if [ $damp0 -lt 300 ]; then
		damp0=300
	fi
	fan=1
fi
if [ $fan -eq 0 ]; then
	damp0=270
fi
damp1=$damp0
# scale them for integer math
rs1=`expr $rs \* 1000`
hd1=`expr $hd \* 1000`
cod1=`expr $cod \* 1000`
if [ $retAirT -ne $rs1 ]; then
	retAirT=`expr $retAirT + $deltaT`
fi
if [ $retAirT -lt $cod1 ]; then
	if [ $fan -ne 0 ]; then
		retAirT=$cod1
	fi
elif [ $retAirT -gt $hd1 ]; then
	if [ $fan -ne 0 ]; then
		retAirT=$hd1
	fi
fi
rat=`expr $retAirT / 1000`
#echo "retA $retAirT $deltaT"
#
# output desired result format
if [ "$1" == "-r" ]; then
	echo -n "\$$hs, $cs, $hv, $cv, $hd, $cod, $hu, $co, $rat, "
	echo "$fan, $damp0, $damp1, $damp2, $retAirT, $deltaT*"
elif [ "$1" == "-p" ]; then
	echo -n "oSP=$outAirT&rSP=$rs&pSP=$ro"
	echo -n "&hs=$hs&cs=$cs&hv=$hv&cv=$cv&hd=$hd&cd=$cod&hu=$hu&co=$co"
	echo -n "&ra=$rat&fan=$fan&dp1=$damp0&dp2=$damp1"
	echo    "&dp3=$damp2&rat=$retAirT&dT=$deltaT"
else
	echo "error: bad mode, -p or -r must be supplied"
fi

exit 0

